
#ifndef _XtCalendar_h
#define _XtCalendar_h

/***********************************************************************
 *
 * Calendar Widget
 *
 *
 ***********************************************************************/

#include <X11/Intrinsic.h>

 
/* Class record constants */

extern WidgetClass calendarWidgetClass;

/* Parameters:

 Name                Class              RepType         Default Value
 ----                -----              -------         -------------
 background          Background         Pixel           white
 busy                Busy               Pointer         NULL
 borderWidth         BorderWidth        Dimension       1
 day                 Date               Int             now
 dayFont             Font               XFontStruct*    fixed
 dateJustify         Justify            XtJustify       XtJustifyLeft
 drawGrid            Boolean            Boolean         True
 font                Font               XFontStruct*    fixed
 foreground          Foreground         Pixel           black
 height              Height             Dimension       164
 hiliteFont          Font               XFontStruct*    fixed
 month               Date               Int             now
 monthFont           Font               XFontStruct*    fixed
 numDays             Int                Int             7
 reverseVideo        ReverseVideo       Boolean         False
 showDays            Boolean            Boolean         True
 showMonth           Boolean            Boolean         True
 showYear            Boolean            Boolean         False
 weekMode            Boolean            Boolean         False
 width               Width              Dimension       164
 year                Date               Int             now
*/

#define XmN0bits                "0bits"
#define XmN25bits               "25bits"
#define XmN50bits               "50bits"
#define XmN75bits               "75bits"
#define XmN100bits              "100bits"
#define XmNselectedBits         "selectedBits"
#define XmNbusy                 "busy"
#define XmNclickProc            "clickProc"
#define XmNchanged              "changed"
#define XmNdateExtProc          "dateExtProc"
#define XmNdateJustify          "dateJustify"
#define XmNdateProc             "dateProc"
#define XmNday                  "day"
#define XmNdayFont              "dayFont"
#define XmNdrawGrid             "drawGrid"
#define XmNhiliteFont           "hiliteFont"
#define XmNnumDays              "numDays"
#define XmNmonth                "month"
#define XmNmonthFont            "monthFont"
#define XmNmonthProc            "monthProc"
#define XmNshowDays             "showDays"
#define XmNshowMonth            "showMonth"
#define XmNshowYear             "showYear"
#define XmNweekMode             "weekMode"
#define XmNyear                 "year"
#define XmNyearProc             "yearProc"

#define XmCBusy                 "Busy"
#define XmCDate                 "Date"
#define XmCNum                  "Num" /* s.b. cardinal or something */

#define SELECTED 1
#define SELECTING 2
#define SPECIAL 4

typedef struct _CalendarClassRec *CalendarWidgetClass;
typedef struct _CalendarRec      *CalendarWidget;

typedef struct _CalendarSelection
{
int month, day, year;
} CalendarSelection;

extern void CalGetSelInfo();
extern void CalSetSelInfo();

/* week mode hacks */
#define FIRSTDAY 0
#define VISDAYS 7
#define FIRSTDIVISION 18
#define VISDIVISIONS 18

#define DAYS 7
#define HOURS 24
#define HDIVISIONS 2

typedef struct
{
  int when[DAYS][HOURS*HDIVISIONS];
} busy;

#endif _XtCalendar_h
/* DON'T ADD STUFF AFTER THIS #endif */






