#include <stdio.h>
#include <X11/copyright.h>

/* $XConsortium: Template.c,v 1.2 88/10/25 17:40:25 swick Exp $ */
/* Copyright	Massachusetts Institute of Technology	1987, 1988 */
#include <Xm/XmP.h>    
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>    
#include <X11/Shell.h>
#include <X11/ShellP.h>
#include <Xm/MenuShell.h>
#include <Xm/MenuShellP.h>
#include "MuMenuP.h"
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/CascadeB.h>
#include <ctype.h>    
    
#define offset(field) XtOffset(MuMenuWidget, muMenu.field)
static XtResource resources[] = {
    {XmNitems, XmCItems, XtRString,
     sizeof(String), offset(items), XtRString, NULL}
};
#undef offset

static void Initialize(MuMenuWidget, MuMenuWidget);
static void ClassInitialize();

#define superclass (&xmRowColumnClassRec)

MuMenuClassRec muMenuClassRec = {
  { /* core fields */
    /* superclass		*/	(WidgetClass) superclass,
    /* class_name		*/	"MuMenu",
    /* widget_size		*/	sizeof(MuMenuRec),
    /* class_initialize		*/	ClassInitialize,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	FALSE,
    /* initialize		*/	Initialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	XtInheritRealize,
    /* actions			*/	NULL,
    /* num_actions		*/	0,
    /* resources		*/	resources,
    /* num_resources		*/	XtNumber(resources),
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	FALSE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	NULL,
    /* resize			*/	XtInheritResize,
    /* expose			*/	XtInheritExpose,
    /* set_values		*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	XtInheritTranslations,
    /* query_geometry		*/	XtInheritQueryGeometry,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL
  },
    {                  /* composite class record */
        XtInheritGeometryManager, /* childrens geo mgr proc */
        XtInheritChangeManaged,   /* set changed proc */
        XtInheritInsertChild,     /* add a child */
        XtInheritDeleteChild,     /* remove a child */
        NULL,                     /* extension */
    },
    {                  /* constraint class record */
        NULL,                    /* constraint resources */
        0,                       /* constraint resource_count */
        sizeof(XmRowColumnConstraintRec),  /* constraint_size */
        NULL,                    /* initialize */
        NULL,                    /* destroy */
        NULL,                    /* set_values */
        NULL,                    /* extension */
    },
    {                  /* manager class record */
        (XtTranslations)_XtInherit,  /* translations */
        NULL,                        /* get_resources */
        0,                           /* num_get_resources */
        NULL,                    /* get_constraint_resources */
        0,                       /* num_get_constraint_resources */
        NULL,                    /* extension */
    },
    {                  /* row column class record */
        NULL,			/* proc to interface with menu widgets */
	NULL,			/* proc to arm&activate menu */
	NULL,			/* traversal handler */
	NULL,			/* extension */
#ifdef MOTIF_10
	NULL,        /* proc to position a menu */
        NULL,        /* proc to set cascadeBtn field */
        NULL,        /* proc to arm&activate menu */
        NULL,        /* proc to popdown menu */
        NULL,        /* proc to arm menu */
        NULL,        /* proc to change traversal */
        NULL,        /* proc to disarm menu */
        NULL,        /* traversal handler */
        NULL,        /* cleans up PM menubar traversal mode */
        NULL,                      /* extension */
#endif
    },
    { /* muMenu fields */
      /* empty		     */	0
    }
};

WidgetClass muMenuWidgetClass = (WidgetClass)&muMenuClassRec;


/* Hash table declarations */

struct bucket {
    struct bucket *next;
    int key;
    Widget data;
};
struct hash {
    int size;
    struct bucket **data;
};

/* hashing routines should be with ints to be cast to Widgets
 * and XtCallbackProcs, not cast from Widgets...
 */
extern struct hash *create_hash();
extern Widget hash_lookup();
extern int hash_store();
static struct hash *table = NULL;
#define HASHSIZE 67

void MuRegisterMenuCallbacks(c, num )
MuCallbacksRec c[];
int num;
{
  int i;
  XrmQuark quark;
  char err_buf[100];

  if ( table == NULL )
    table = create_hash(HASHSIZE);

  for ( i = 0; i < num; i++ )
    {
      quark = XrmStringToQuark( c[i].name );
      if ( 1 == hash_store( table, quark, (Widget) c[i].proc ) )
	{
	  sprintf( err_buf,
	  "MuRegisterMenuCallbacks: duplicate procedure registration: %s",
		  c[i].name );
	  XtWarning( err_buf );
	}
    }
}

XtCallbackProc MuGetMenuCallback( name )
char *name;
{
  XrmQuark quark;

  quark = XrmStringToQuark( name );
  if ( table != NULL )
    return ( XtCallbackProc )(hash_lookup( table, quark ));
  else
    return NULL;
}


static void ClassInitialize()
{
/* got to fix up inheritance myself, since RowColumn won't do it for me */
#define inherit(field) muMenuClassRec.row_column_class.field = superclass->row_column_class.field

    inherit(menuProcedures);
    inherit(armAndActivate);
    inherit(traversalHandler);
#ifdef MOTIF_10
    inherit(position);
    inherit(setCascade);
    inherit(menuPopdown);
    inherit(menuArm);
    inherit(setMenuTraversal);
    inherit(menuDisarm);
    inherit(menuBarCleanup);
#endif
#undef inherit    
}

#define ITYPENONE 0
#define ITYPEBUTTON 1
#define ITYPESEPARATOR 2
#define ITYPECASCADE 3
#define ITYPETOGGLEON 4
#define ITYPETOGGLEOFF 5

#define PTYPENULL 0
#define PTYPESTR 1
#define PTYPEINT 2

/*
 * Return first occurrence of what that's not in quotes
 * does the right thing for what == '"' :)
 */
static char *indexq( where, what )
char *where, what;
{
int inquotes = 0, found = 0;

while ( !found && *where )
  {
    if ( !inquotes && *where == what )
      found = 1;
    else
      {
	if ( *where == '"' )
	  inquotes = 1 - inquotes;
	where++;
      }
  }
return (char *) (found * (int) where);
}

#define min( a, b ) a < b ? a : b

#define MAXLINE 80

static void Initialize(MuMenuWidget request, MuMenuWidget new)
{
    static char rtn[] = "MuCreateMenuBar:";
    char *i, *items, *endquote, *ptr, *label;
    char *end, *somethingtoparse;

    char un, itemname[100], subname[100], procname[100], scratch[100];
    char err_buf[300], thisline[100];

    int ptype, ishelp;
    char strparm[100];
    int intparm;
    char widgetname[100];
    Widget w;
    char *cbName;
    XtCallbackProc proc;
    caddr_t data;
    Arg args[5];
    int n;

    int numitems, type;

    items = new->muMenu.items;
    end = index( items, '\0' );

    for ( i = items, numitems=0; i < end; numitems++ )
      {
	sprintf( widgetname, "item%d", numitems );
	itemname[0] = '\0'; /* displayed menu item name */
	subname[0] = '\0'; /* resource name of submenu */
	procname[0] = '\0'; /* name of procedure to call */
	type = ITYPENONE; /* type of menu item */
	ishelp = 0;
	un = '\0'; /* what character to underline in menu item */

	somethingtoparse = indexq( i, ';' );
	if ( somethingtoparse )
	  {
	    strncpy( thisline, i, min(100, somethingtoparse - i + 1));
	    thisline[ min(99, somethingtoparse - i + 1) ] = '\0';
	  }
	else
	  {
	    sprintf( err_buf, "%s no ';' found in:\n%s\n", rtn, i );
	    XtWarning( err_buf );
	    i = end;
	  }

	/* skip over white space */
	while (isspace(*i)) i++;

	while ( somethingtoparse )
	  {
	    switch( *i )
	      {
	      case '"': /* parse name */
		i++;
		endquote = index( i, '"' );
		/*
		 * there has to be an endquote in this parse interpretation
		 * so endquote guaranteed not == 0
		 */
		if ( !strncmp( i, "------------", endquote - i ) )
		  {
		    type = ITYPESEPARATOR;
		    i = endquote + 1;
		  }
		else /* parse non-separator name */
		  {
		    if ( type == ITYPENONE ) /* don't override toggle */
		      type = ITYPEBUTTON;
		    
		    ptr = itemname;

		    while ( i < endquote )
		      {
			if ( *i == '_' )
			  un = *(++i);
			*ptr++ = *i++;
		      }
		    *ptr = '\0';
		    i++;
		  }
		break;

	      case '-': /* parse submenu stuff */
		type = ITYPECASCADE;
		endquote = index( i+1, '>' );
		if ( !endquote || endquote > somethingtoparse )
		  {
		    sprintf( err_buf,
			    "%s missing symbol '>' in submenu:\n%s\n",
			    rtn, thisline );
		    XtWarning( err_buf );
		    i = somethingtoparse; /* ignore line */
		    type = ITYPENONE;
		  }
		else
		  {
		    i = endquote + 1;
		    while (isspace(*i)) i++;
		    ptr = subname;
		    while ( !isspace(*i) && i < somethingtoparse )
		      *ptr++ = *i++;
		    *ptr = '\0';
		  }
		break;

	      default: /* parse everything else; s.b. guaranteed not ';' */
		ptr = scratch;
		while ( !isspace(*i) && *i != '(' && i < somethingtoparse )
		  *ptr++ = *i++;
		*ptr = '\0';

		if ( *i != '(' ) /* then a flag */
		  {
		    if ( !strcmp( scratch, "togon" ) )
		      type = ITYPETOGGLEON;
		    else
		      {
			if ( !strcmp( scratch, "togoff" ) )
			  type = ITYPETOGGLEOFF;
			else
			  {
			    if ( !strcmp( scratch, "help" ) )
			      ishelp = 1;
			    else
			      {
				sprintf( err_buf,
					"%s unknown flag: %.25s in \n%s\n",
					rtn, scratch, thisline );
				XtWarning( err_buf );
				i = somethingtoparse; /* ignore line */
				type = ITYPENONE;
			      }
			  }
		      }
		  }
		else /* parse proc stuff */
		  {
		    if ( type == ITYPENONE ) /* don't override toggle */
		      type = ITYPEBUTTON;

		    strcpy( procname, scratch );

		    i++;
		    while (isspace(*i)) i++;

		    if ( *i == '"' ) /* string */
		      {
			ptype = PTYPESTR;
			i++;
			endquote = index( i, '"' );

			strncpy( strparm, i, endquote - i );
			strparm[endquote - i] = '\0';

			i = endquote + 1;
			while (isspace(*i)) i++;
			if ( *i != ')' )
			  {
			    sprintf( err_buf,
			    "%s missing ')' after parameter in:\n%s\n",
				    rtn, thisline );
			    XtWarning( err_buf );
			    i = somethingtoparse; /* ignore line */
			    type = ITYPENONE;
			  }
			else
			  i++;
		      }
		    else /* int or NULL */
		      {
			if ( *i == ')' ) /* NULL */
			  {
			    ptype = PTYPENULL;
			    i++;
			  }
			else /* int */
			  {
			    ptr = strparm;
			    while ( *i != ')' && i < somethingtoparse )
			      *ptr++ = *i++;
			    *ptr = '\0';

			    intparm = atoi( strparm );
			    ptype = PTYPEINT;

			    if ( *i != ')' )
			      {
				sprintf( err_buf,
				"%s missing ')' after parameter in:\n%s\n",
					rtn, thisline );
				XtWarning( err_buf );
				i = somethingtoparse; /* ignore line */
				type = ITYPENONE;
			      }
			    else
			      i++;
			  }
		      }
		  }
	      } /* end of switch */

	    while (isspace(*i)) i++;
	    if ( *i == ';' )
	      {
		i++;
		somethingtoparse = NULL;
	      }
	    while (isspace(*i)) i++;

	    if ( *i == '\0' )
	      somethingtoparse = NULL;
	  } /* end while (somethingtoparse) */
	/* now it's all been parsed into the proper variables */

	n = 0;
	/* choose the label */
	if ( type != ITYPESEPARATOR )
	  {
	    if ( itemname[0] != '\0' )
	      ptr = itemname;
	    else
	      if ( itemname[0] != '\0' )
		ptr = subname;
	      else
		if ( itemname[0] != '\0' )
		  ptr = procname;
		else
		  ptr = widgetname;
	    label = XmStringCreateLtoR( ptr, XmSTRING_DEFAULT_CHARSET );
	    XtSetArg( args[n], XmNlabelString, label ); n++;
	  }

	if ( un != '\0' ) /* not possible for separator (put inside anyway) */
	  {
	    XtSetArg( args[n], XmNmnemonic, un );
	    n++;
	  }

	switch( type )
	  {
	  case ITYPESEPARATOR:
	    w = XmCreateSeparatorGadget( new, widgetname, NULL, 0 );
	    break;
	  case ITYPEBUTTON:
	    w = XmCreatePushButtonGadget( new, widgetname, args, n );
	    cbName = XmNactivateCallback;
	    break;
	  case ITYPETOGGLEON:
	    XtSetArg( args[n], XmNset, (Boolean) True ); n++;
	  case ITYPETOGGLEOFF:
	    w = XmCreateToggleButtonGadget( new, widgetname, args, n );
	    cbName = XmNvalueChangedCallback;
	    break;
	  case ITYPECASCADE:
	    w = MuCreateMenuPane( new, subname, NULL, 0 );
	    XtSetArg( args[n], XmNsubMenuId, w ); n++;
	    sprintf( scratch, "%s_button", subname );
	    w = XmCreateCascadeButton( new, scratch, args, n );
	    break;
	  default:
	    w = (Widget) NULL;
	  }

	if ( w )
	  {
	    if ( ishelp )
	      {
		XtSetArg( args[0], XmNmenuHelpWidget, w );
		XtSetValues( new, args, 1 );
	      }
	    if ( procname[0] != '\0' )
	      {
		switch( ptype )
		  {
		  case PTYPENULL:
		    data = (caddr_t) NULL;
		    break;
		  case PTYPESTR:
		    data = (caddr_t) XtNewString( (String) strparm );
		    break;
		  case PTYPEINT:
		    data = (caddr_t) intparm;
		    break;
		  }
		proc = MuGetMenuCallback( procname );
		if ( proc != NULL )
		  XtAddCallback( w, cbName, proc, data );
		else
		  {
		    sprintf( err_buf,
			    "%s unregistered function %s",
			    rtn, procname );
		    XtWarning( err_buf );
		  }
	      }
	    XtManageChild( w );
	  }
      }
  }

#define IsPopup(m)     \
    (((XmRowColumnWidget) (m))->row_column.type == XmMENU_POPUP)
#define IsPulldown(m)  \
    (((XmRowColumnWidget) (m))->row_column.type == XmMENU_PULLDOWN)
#define IsOption(m)    \
    (((XmRowColumnWidget) (m))->row_column.type == XmMENU_OPTION)
#define IsBar(m)       \
    (((XmRowColumnWidget) (m))->row_column.type == XmMENU_BAR)

Widget MuCreateMenuBar(Widget p, String name, Arg *args, int count)
{
    Arg al[50];
    int ac = 0;
    Widget m;
    int i;

    /* copy arglist and add the rowColumnType resource */
    for (i=0; i<count; i++) al[ac++] = args[i];  
    XtSetArg (al[ac], XmNrowColumnType,  XmMENU_BAR); ac++;
    m = XtCreateWidget (name, muMenuWidgetClass, p, al, ac);
    return (m);
}

Widget MuCreateMenuPane(Widget p, String name, Arg *args, int count)
{
    Arg al[50];
    int ac = 0;
    Widget m;
    int i;
    Arg s_al[25];
    XmMenuShellWidget pop = NULL;
    Widget pw;
    int s_ac = 0;
    char b[200];

    for (i=0; i<count; i++) al[ac++] = args[i];  /* copy into our list */

    /* force it to be a menu pane */
    XtSetArg (al[ac], XmNrowColumnType,  XmMENU_PULLDOWN); ac++;

    /*
     * if this is a pulldown of a pulldown or popup then the parent
     * should really be the shell of the parent not the indicated 
     * parent, this keeps the cascade tree correct
     */
    
    if ((XtParent(p) != NULL) && XmIsMenuShell(XtParent (p)))
	pw = XtParent (p);
    else
	pw = p;
    
    /* now we need a shell widget */

    /* 
     * Shared menupanes are supported for all menu types but the option
     * menu.  If this is not an option menupane, then see if a shell is
     * already present; if so, then we'll use it.
     */
    if (XmIsRowColumn(p) && (IsBar(p) || IsPopup(p) || IsPulldown(p)))
    {
	for (i = 0; i < pw->core.num_popups; i++)
	{
	    if ((XmIsMenuShell(pw->core.popup_list[i])) &&
		(((XmMenuShellWidget)pw->core.popup_list[i])->menu_shell.
		 private_shell) &&
		(!(pw->core.popup_list[i])->core.being_destroyed))
	    {
		pop = (XmMenuShellWidget)pw->core.popup_list[i];
		break;
	    }
	}
    }
    
    /* No shell - create a new one */
    if (pop == NULL)
    {
	XtSetArg (s_al[s_ac], XmNwidth,             5);     s_ac++;
	XtSetArg (s_al[s_ac], XmNheight,        5);     s_ac++;
	XtSetArg (s_al[s_ac], XmNallowShellResize, TRUE);   s_ac++;
	XtSetArg (s_al[s_ac], XtNoverrideRedirect, TRUE);   s_ac++;
	
	sprintf (b, "popup_%s", name);
	
	pop = (XmMenuShellWidget)
	    XtCreatePopupShell(b, xmMenuShellWidgetClass, pw, s_al, s_ac);
	
	/* Mark the shell as having been created by us */
	pop->menu_shell.private_shell = True;
    }
    
    m = XtCreateWidget (name, muMenuWidgetClass, pop, al, ac);
    
    return (m);
}


