#include <stdio.h>
#include <strings.h>
#include <errno.h>
#include <sys/file.h>
#include <zephyr/zephyr.h>

#define USERS "/site/calserver/users"

static int zinited = 0;

void zinit()
{
  int status;

  if ((status = ZInitialize()) != ZERR_NONE)
    {
      fprintf(stderr, "Zephyr initialization failed with error %d.\n",
	      status);
      return;
    }

  zinited = 1;
}

void zwrite(user, sender)
char *user, *sender;
{
  char buffer[100];
  int status;
  ZNotice_t notice;

  if (!zinited)
    return;

  sprintf(buffer, "New transaction from user %s.", sender);

  bzero((char *)&notice, sizeof(notice));

  notice.z_kind = UNACKED;
  notice.z_port = 0;
  notice.z_class = "calendar";
  notice.z_class_inst = "appointment";
  notice.z_opcode = "";
  notice.z_sender = "Calendar Service";
  notice.z_recipient = user;
  notice.z_default_format = "Message from calendar service at $fromhost:\n$message";
  notice.z_message = buffer;
  notice.z_message_len = strlen(notice.z_message) + 1;

  if ((status = ZSendNotice(&notice, ZNOAUTH)) != ZERR_NONE)
    fprintf(stderr, "Zephyr failed to send notice to %s.\n", user);
}

int main(argc, argv)
int argc;
char **argv;
{
  FILE *f, *g;
  char username[50];
  char sender[50];
  char filename[100];
  int e = 0;
  char tmp;

  if (argc < 3)
    {
      fprintf(stderr, "usage: %s filename trans#\n", argv[0]);
      exit(1);
    }

  zinit();

  /* we shouldn't need to lock it because noone but us knows it exists yet,
     'cause we're the one to tell them! */
  f = fopen(argv[1], "r");

  /* not checking for f == NULL */

  fgets(sender, 50, f); /* sender */
  sender[index(sender, '\n') - sender] = '\0';

  fgets(username, 50, f); /* skip authentication */

  while ('-' != (tmp = getc(f)))
    {
      ungetc(tmp, f);
      fgets(username, 50, f);

      /* clean up username */
      username[index(username, ' ') - username] = '\0';

      /* this is where we need to check daemonhood */
      sprintf(filename, "%s/%s", USERS, username);

      g = fopen(filename, "a");
      flock(fileno(g), LOCK_EX); /* block */

      /* we need to do this because the end of file may have moved
         between the time we opened the file and the time we got
         our exclusive lock. Ain't UNIX great? */
      fseek(g, 0, 2);

      fprintf(g, "%s\n", argv[2]);

      /* we can't close before we unlock; if we don't flush before we
	 unlock, the next guy might position to our pre-flushed state
	 and start writing before we close. Ain't UNIX great? */
      fflush(g);

      flock(fileno(g), LOCK_UN);

      fclose(g);

      zwrite(username, sender);
    }

  fclose(f);
  return 0;
}
